package pod_test

import (
	. "github.com/onsi/ginkgo"
	. "github.com/onsi/gomega"

	"k8s.libre.sh/meta"
	container "k8s.libre.sh/objects/container"
	. "k8s.libre.sh/objects/pod"
	parameters "k8s.libre.sh/settings"

	corev1 "k8s.io/api/core/v1"
)

var _ = Describe("Pod", func() {
	Describe("Mutate Pod", func() {
		Context("With a single container", func() {
			It("should generate pod with single container", func() {

				pod := Pod{
					PodSpec: &PodSpec{
						ObjectMeta: &meta.ObjectMeta{
							Name:      "test",
							Namespace: "test",
							//	Labels:
						},
						//	Resources:       corev1.ResourceRequirements{},
						//	SecurityContext: &corev1.PodSecurityContext{},
						//	Affinity:        &corev1.Affinity{},
						//	RestartPolicy:   "restart",
						//	Tolerations:  []corev1.Toleration{},
						//	NodeSelector: map[string]string{},
						Container: container.Container{
							TemplateSpec: &container.TemplateSpec{
								Name: "mycontainer",
							},
							Settings: parameters.Settings{
								// TODO FIX PARAMETERS HAS TO BE INITIALIZE OR NIL POINTER RECEIVER ERROR
								// ENVFROM & ENV returns empty array it should return nil
								Parameters: new(parameters.Parameters),
							},
						},
						//	ExtraContainers: []container.Container{},
						//	InitContainers:  []container.Container{},
					},
				}

				//			initialObject := &corev1.Pod{
				//				Spec: corev1.PodSpec{
				//					Containers: []corev1.Container{
				//						corev1.Container{
				//							Name: "mycontainer",
				//						},
				//					},
				//				},
				//			}

				initialObject := &corev1.PodTemplateSpec{}

				expectedObj := corev1.PodSpec{
					Containers: []corev1.Container{
						corev1.Container{
							Name: "mycontainer",
						},
					},
				}

				err := MutatePod(pod, initialObject)

				Expect(initialObject.Spec).To(Equal(expectedObj))
				Expect(err).NotTo(HaveOccurred())
			})
		})
	})
})
